//Thanks to Paul Bourke (http://astronomy.swin.edu.au/~pbourke/) who provided the coordinates
V3D.Tetrahedron=function(aParentScene, aFrontColor, aBackColor, aStrokeColor, aStrokeWeight)
{ V3D.Object3D.call(this);
  this.Parent=aParentScene;
  this.ClassName="Tetrahedron";  
  this.FrontColor=aFrontColor;
  this.BackColor=aBackColor;
  this.StrokeColor=aStrokeColor;
  this.StrokeWeight=aStrokeWeight; 
  var a=0.5;
  this.Poly3D[0]=new V3D.Poly3D(aParentScene, aFrontColor, aBackColor, aStrokeColor, aStrokeWeight);
  with (this.Poly3D[0])
  { AddPoint(a,a,a); AddPoint(-a,a,-a); AddPoint(a,-a,-a); Update(); }
  this.Poly3D[1]=new V3D.Poly3D(aParentScene, aFrontColor, aBackColor, aStrokeColor, aStrokeWeight);
  with (this.Poly3D[1])
  { AddPoint(-a,a,-a); AddPoint(-a,-a,a); AddPoint(a,-a,-a); Update(); }
  this.Poly3D[2]=new V3D.Poly3D(aParentScene, aFrontColor, aBackColor, aStrokeColor, aStrokeWeight);
  with (this.Poly3D[2])
  { AddPoint(a,a,a); AddPoint(a,-a,-a); AddPoint(-a,-a,a); Update(); }
  this.Poly3D[3]=new V3D.Poly3D(aParentScene, aFrontColor, aBackColor, aStrokeColor, aStrokeWeight);
  with (this.Poly3D[3])
  { AddPoint(a,a,a); AddPoint(-a,-a,a); AddPoint(-a,a,-a); Update(); }
}
V3D.Octahedron=function(aParentScene, aFrontColor, aBackColor, aStrokeColor, aStrokeWeight)
{ V3D.Object3D.call(this);
  this.Parent=aParentScene;
  this.ClassName="Octahedron";
  this.FrontColor=aFrontColor;
  this.BackColor=aBackColor;
  this.StrokeColor=aStrokeColor;
  this.StrokeWeight=aStrokeWeight;
  var a=Math.sqrt(0.125), b=0.5;
  this.Poly3D[0]=new V3D.Poly3D(aParentScene, aFrontColor, aBackColor, aStrokeColor, aStrokeWeight);
  with (this.Poly3D[0])
  { AddPoint(-a,0,a); AddPoint(-a,0,-a); AddPoint(0,b,0); Update(); }
  this.Poly3D[1]=new V3D.Poly3D(aParentScene, aFrontColor, aBackColor, aStrokeColor, aStrokeWeight);
  with (this.Poly3D[1])
  { AddPoint(-a,0,-a); AddPoint(a,0,-a); AddPoint(0,b,0); Update(); }
  this.Poly3D[2]=new V3D.Poly3D(aParentScene, aFrontColor, aBackColor, aStrokeColor, aStrokeWeight);
  with (this.Poly3D[2])
  { AddPoint(a,0,-a); AddPoint(a,0,a); AddPoint(0,b,0); Update(); }
  this.Poly3D[3]=new V3D.Poly3D(aParentScene, aFrontColor, aBackColor, aStrokeColor, aStrokeWeight);
  with (this.Poly3D[3])
  { AddPoint(a,0,a); AddPoint(-a,0,a); AddPoint(0,b,0); Update(); }
  this.Poly3D[4]=new V3D.Poly3D(aParentScene, aFrontColor, aBackColor, aStrokeColor, aStrokeWeight);
  with (this.Poly3D[4])
  { AddPoint(a,0,-a); AddPoint(-a,0,-a); AddPoint(0,-b,0); Update(); }
  this.Poly3D[5]=new V3D.Poly3D(aParentScene, aFrontColor, aBackColor, aStrokeColor, aStrokeWeight);
  with (this.Poly3D[5])
  { AddPoint(-a,0,-a); AddPoint(-a,0,a); AddPoint(0,-b,0); Update(); }
  this.Poly3D[6]=new V3D.Poly3D(aParentScene, aFrontColor, aBackColor, aStrokeColor, aStrokeWeight);
  with (this.Poly3D[6])
  { AddPoint(a,0,a); AddPoint(a,0,-a); AddPoint(0,-b,0); Update(); }
  this.Poly3D[7]=new V3D.Poly3D(aParentScene, aFrontColor, aBackColor, aStrokeColor, aStrokeWeight);
  with (this.Poly3D[7])
  { AddPoint(-a,0,a); AddPoint(a,0,a); AddPoint(0,-b,0); Update(); }
}
V3D.Cube=function(aParentScene, aFrontColor, aBackColor, aStrokeColor, aStrokeWeight)
{ V3D.Object3D.call(this);
  this.Parent=aParentScene;
  this.ClassName="Cube";
  this.FrontColor=aFrontColor;
  this.BackColor=aBackColor;
  this.StrokeColor=aStrokeColor;
  this.StrokeWeight=aStrokeWeight;
  var a=0.5;
  this.Poly3D[0]=new V3D.Poly3D(aParentScene, aFrontColor, aBackColor, aStrokeColor, aStrokeWeight);
  with (this.Poly3D[0])
  { AddPoint(-a,-a,a); AddPoint(a,-a,a); AddPoint(a,-a,-a); AddPoint(-a,-a,-a); Update(); }
  this.Poly3D[1]=new V3D.Poly3D(aParentScene, aFrontColor, aBackColor, aStrokeColor, aStrokeWeight);
  with (this.Poly3D[1])
  { AddPoint(-a,a,-a); AddPoint(-a,a,a); AddPoint(-a,-a,a); AddPoint(-a,-a,-a); Update(); }
  this.Poly3D[2]=new V3D.Poly3D(aParentScene, aFrontColor, aBackColor, aStrokeColor, aStrokeWeight);
  with (this.Poly3D[2])
  { AddPoint(-a,a,a); AddPoint(a,a,a); AddPoint(a,-a,a); AddPoint(-a,-a,a); Update(); }
  this.Poly3D[3]=new V3D.Poly3D(aParentScene, aFrontColor, aBackColor, aStrokeColor, aStrokeWeight);
  with (this.Poly3D[3])
  { AddPoint(a,a,-a); AddPoint(a,a,a); AddPoint(-a,a,a); AddPoint(-a,a,-a); Update(); }
  this.Poly3D[4]=new V3D.Poly3D(aParentScene, aFrontColor, aBackColor, aStrokeColor, aStrokeWeight);
  with (this.Poly3D[4])
  { AddPoint(a,-a,a); AddPoint(a,a,a); AddPoint(a,a,-a); AddPoint(a,-a,-a); Update(); }
  this.Poly3D[5]=new V3D.Poly3D(aParentScene, aFrontColor, aBackColor, aStrokeColor, aStrokeWeight);
  with (this.Poly3D[5])
  { AddPoint(a,-a,-a); AddPoint(a,a,-a); AddPoint(-a,a,-a); AddPoint(-a,-a,-a); Update(); }
}
V3D.Icosahedron=function(aParentScene, aFrontColor, aBackColor, aStrokeColor, aStrokeWeight)
{ V3D.Object3D.call(this);
  this.Parent=aParentScene;
  this.ClassName="Icosahedron";
  this.FrontColor=aFrontColor;
  this.BackColor=aBackColor;
  this.StrokeColor=aStrokeColor;
  this.StrokeWeight=aStrokeWeight;
  var a=0.5, b=1.0/(1.0+Math.sqrt(5.0));
  this.Poly3D[0]=new V3D.Poly3D(aParentScene, aFrontColor, aBackColor, aStrokeColor, aStrokeWeight);
  with (this.Poly3D[0])
  { AddPoint(0,b,-a); AddPoint(b,a,0); AddPoint(-b,a,0); Update(); }
  this.Poly3D[1]=new V3D.Poly3D(aParentScene, aFrontColor, aBackColor, aStrokeColor, aStrokeWeight);
  with (this.Poly3D[1])
  { AddPoint(0,b,a); AddPoint(-b,a,0); AddPoint(b,a,0); Update(); }
  this.Poly3D[2]=new V3D.Poly3D(aParentScene, aFrontColor, aBackColor, aStrokeColor, aStrokeWeight);
  with (this.Poly3D[2])
  { AddPoint(0,b,a); AddPoint(0,-b,a); AddPoint(-a,0,b); Update(); }
  this.Poly3D[3]=new V3D.Poly3D(aParentScene, aFrontColor, aBackColor, aStrokeColor, aStrokeWeight);
  with (this.Poly3D[3])
  { AddPoint(0,b,a); AddPoint(a,0,b); AddPoint(0,-b,a); Update(); }
  this.Poly3D[4]=new V3D.Poly3D(aParentScene, aFrontColor, aBackColor, aStrokeColor, aStrokeWeight);
  with (this.Poly3D[4])
  { AddPoint(0,b,-a); AddPoint(0,-b,-a); AddPoint(a,0,-b); Update(); }
  this.Poly3D[5]=new V3D.Poly3D(aParentScene, aFrontColor, aBackColor, aStrokeColor, aStrokeWeight);
  with (this.Poly3D[5])
  { AddPoint(0,b,-a); AddPoint(-a,0,-b); AddPoint(0,-b,-a); Update(); }
  this.Poly3D[6]=new V3D.Poly3D(aParentScene, aFrontColor, aBackColor, aStrokeColor, aStrokeWeight);
  with (this.Poly3D[6])
  { AddPoint(0,-b,a); AddPoint(b,-a,0); AddPoint(-b,-a,0); Update(); }
  this.Poly3D[7]=new V3D.Poly3D(aParentScene, aFrontColor, aBackColor, aStrokeColor, aStrokeWeight);
  with (this.Poly3D[7])
  { AddPoint(0,-b,-a); AddPoint(-b,-a,0); AddPoint(b,-a,0); Update(); }
  this.Poly3D[8]=new V3D.Poly3D(aParentScene, aFrontColor, aBackColor, aStrokeColor, aStrokeWeight);
  with (this.Poly3D[8])
  { AddPoint(-b,a,0); AddPoint(-a,0,b); AddPoint(-a,0,-b); Update(); }
  this.Poly3D[9]=new V3D.Poly3D(aParentScene, aFrontColor, aBackColor, aStrokeColor, aStrokeWeight);
  with (this.Poly3D[9])
  { AddPoint(-b,-a,0); AddPoint(-a,0,-b); AddPoint(-a,0,b); Update(); }
  this.Poly3D[10]=new V3D.Poly3D(aParentScene, aFrontColor, aBackColor, aStrokeColor, aStrokeWeight);
  with (this.Poly3D[10])
  { AddPoint(b,a,0); AddPoint(a,0,-b); AddPoint(a,0,b); Update(); }
  this.Poly3D[11]=new V3D.Poly3D(aParentScene, aFrontColor, aBackColor, aStrokeColor, aStrokeWeight);
  with (this.Poly3D[11])
  { AddPoint(b,-a,0); AddPoint(a,0,b); AddPoint(a,0,-b); Update(); }
  this.Poly3D[12]=new V3D.Poly3D(aParentScene, aFrontColor, aBackColor, aStrokeColor, aStrokeWeight);
  with (this.Poly3D[12])
  { AddPoint(0,b,a); AddPoint(-a,0,b); AddPoint(-b,a,0); Update(); }
  this.Poly3D[13]=new V3D.Poly3D(aParentScene, aFrontColor, aBackColor, aStrokeColor, aStrokeWeight);
  with (this.Poly3D[13])
  { AddPoint(0,b,a); AddPoint(b,a,0); AddPoint(a,0,b); Update(); }
  this.Poly3D[14]=new V3D.Poly3D(aParentScene, aFrontColor, aBackColor, aStrokeColor, aStrokeWeight);
  with (this.Poly3D[14])
  { AddPoint(0,b,-a); AddPoint(-b,a,0); AddPoint(-a,0,-b); Update(); }
  this.Poly3D[15]=new V3D.Poly3D(aParentScene, aFrontColor, aBackColor, aStrokeColor, aStrokeWeight);
  with (this.Poly3D[15])
  { AddPoint(0,b,-a); AddPoint(a,0,-b); AddPoint(b,a,0); Update(); }
  this.Poly3D[16]=new V3D.Poly3D(aParentScene, aFrontColor, aBackColor, aStrokeColor, aStrokeWeight);
  with (this.Poly3D[16])
  { AddPoint(0,-b,-a); AddPoint(-a,0,-b); AddPoint(-b,-a,0); Update(); }
  this.Poly3D[17]=new V3D.Poly3D(aParentScene, aFrontColor, aBackColor, aStrokeColor, aStrokeWeight);
  with (this.Poly3D[17])
  { AddPoint(0,-b,-a); AddPoint(b,-a,0); AddPoint(a,0,-b); Update(); }
  this.Poly3D[18]=new V3D.Poly3D(aParentScene, aFrontColor, aBackColor, aStrokeColor, aStrokeWeight);
  with (this.Poly3D[18])
  { AddPoint(0,-b,a); AddPoint(-b,-a,0); AddPoint(-a,0,b); Update(); }
  this.Poly3D[19]=new V3D.Poly3D(aParentScene, aFrontColor, aBackColor, aStrokeColor, aStrokeWeight);
  with (this.Poly3D[19])
  { AddPoint(0,-b,a); AddPoint(a,0,b); AddPoint(b,-a,0); Update(); }
}
V3D.Dodecahedron=function(aParentScene, aFrontColor, aBackColor, aStrokeColor, aStrokeWeight)
{ V3D.Object3D.call(this);
  this.Parent=aParentScene;
  this.ClassName="Dodecahedron";
  this.FrontColor=aFrontColor;
  this.BackColor=aBackColor;
  this.StrokeColor=aStrokeColor;
  this.StrokeWeight=aStrokeWeight;
  var a=1.0/(1.0+Math.sqrt(5.0)), b=(1.0+Math.sqrt(5.0))/4.0, c=0.5;
  this.Poly3D[0]=new V3D.Poly3D(aParentScene, aFrontColor, aBackColor, aStrokeColor, aStrokeWeight);
  with (this.Poly3D[0])
  { AddPoint(-c,-c,c); AddPoint(-b,0,a); AddPoint(-c,c,c); AddPoint(0,a,b); AddPoint(0,-a,b); Update(); }
  this.Poly3D[1]=new V3D.Poly3D(aParentScene, aFrontColor, aBackColor, aStrokeColor, aStrokeWeight);
  with (this.Poly3D[1])
  { AddPoint(0,-a,b); AddPoint(0,a,b); AddPoint(c,c,c); AddPoint(b,0,a); AddPoint(c,-c,c); Update(); }
  this.Poly3D[2]=new V3D.Poly3D(aParentScene, aFrontColor, aBackColor, aStrokeColor, aStrokeWeight);
  with (this.Poly3D[2])
  { AddPoint(c,-c,-c); AddPoint(b,0,-a); AddPoint(c,c,-c); AddPoint(0,a,-b); AddPoint(0,-a,-b); Update(); }
  this.Poly3D[3]=new V3D.Poly3D(aParentScene, aFrontColor, aBackColor, aStrokeColor, aStrokeWeight);
  with (this.Poly3D[3])
  { AddPoint(-c,c,-c); AddPoint(-b,0,-a); AddPoint(-c,-c,-c); AddPoint(0,-a,-b); AddPoint(0,a,-b); Update(); }
  this.Poly3D[4]=new V3D.Poly3D(aParentScene, aFrontColor, aBackColor, aStrokeColor, aStrokeWeight);
  with (this.Poly3D[4])
  { AddPoint(c,-c,-c); AddPoint(a,-b,0); AddPoint(c,-c,c); AddPoint(b,0,a); AddPoint(b,0,-a); Update(); }
  this.Poly3D[5]=new V3D.Poly3D(aParentScene, aFrontColor, aBackColor, aStrokeColor, aStrokeWeight);
  with (this.Poly3D[5])
  { AddPoint(b,0,-a); AddPoint(b,0,a); AddPoint(c,c,c); AddPoint(a,b,0); AddPoint(c,c,-c); Update(); }
  this.Poly3D[6]=new V3D.Poly3D(aParentScene, aFrontColor, aBackColor, aStrokeColor, aStrokeWeight);
  with (this.Poly3D[6])
  { AddPoint(-b,0,-a); AddPoint(-b,0,a); AddPoint(-c,-c,c); AddPoint(-a,-b,0); AddPoint(-c,-c,-c); Update(); }
  this.Poly3D[7]=new V3D.Poly3D(aParentScene, aFrontColor, aBackColor, aStrokeColor, aStrokeWeight);
  with (this.Poly3D[7])
  { AddPoint(-c,c,-c); AddPoint(-a,b,0); AddPoint(-c,c,c); AddPoint(-b,0,a); AddPoint(-b,0,-a); Update(); }
  this.Poly3D[8]=new V3D.Poly3D(aParentScene, aFrontColor, aBackColor, aStrokeColor, aStrokeWeight);
  with (this.Poly3D[8])
  { AddPoint(c,c,c); AddPoint(0,a,b); AddPoint(-c,c,c); AddPoint(-a,b,0); AddPoint(a,b,0); Update(); }
  this.Poly3D[9]=new V3D.Poly3D(aParentScene, aFrontColor, aBackColor, aStrokeColor, aStrokeWeight);
  with (this.Poly3D[9])
  { AddPoint(a,b,0); AddPoint(-a,b,0); AddPoint(-c,c,-c); AddPoint(0,a,-b); AddPoint(c,c,-c); Update(); }
  this.Poly3D[10]=new V3D.Poly3D(aParentScene, aFrontColor, aBackColor, aStrokeColor, aStrokeWeight);
  with (this.Poly3D[10])
  { AddPoint(a,-b,0); AddPoint(-a,-b,0); AddPoint(-c,-c,c); AddPoint(0,-a,b); AddPoint(c,-c,c); Update(); }
  this.Poly3D[11]=new V3D.Poly3D(aParentScene, aFrontColor, aBackColor, aStrokeColor, aStrokeWeight);
  with (this.Poly3D[11])
  { AddPoint(c,-c,-c); AddPoint(0,-a,-b); AddPoint(-c,-c,-c); AddPoint(-a,-b,0); AddPoint(a,-b,0); Update(); }
}