// V3D 1.41 by Lutz Tautenhahn 2023, 2024 based on
// SVG-VML-3D 1.3 by Lutz Tautenhahn 2002-2006
// The Author grants you a non-exclusive, royalty free, license to use,
// modify and redistribute this software.
// This software is provided "as is", without a warranty of any kind.

var V3D={ 

use: "svg", //valid values for "use" are "svg" and "canvas"

Vector: function(xx, yy, zz)
{ this.x=xx;
  this.y=yy;
  this.z=zz;
  this.Set=function(xx, yy, zz)
  { this.x=xx;
    this.y=yy;
    this.z=zz;
  };
  this.Add=function(vv)
  { this.x+=vv.x;
    this.y+=vv.y;
    this.z+=vv.z;
  };
  this.Zoom=function(ff)
  { this.x*=ff;
    this.y*=ff;
    this.z*=ff;
  };
  this.Normalize=function()
  { var ll=0;
    ll+=this.x*this.x;
    ll+=this.y*this.y;
    ll+=this.z*this.z;
    if (ll>0.0)
    { ll=Math.sqrt(ll);
      this.x/=ll;
      this.y/=ll;
      this.z/=ll;
    }
    else this.x=1.0;
  };
},

Scene3D:function(aParentObj, aParentDoc, azIndex, aWidth, aHeight)
{ this.ClassName="Scene3D";
  this.use=V3D.use;
  this.Parent=aParentObj;
  this.Document=aParentDoc;
  this.Context=null;
  this.BoundingBox=null;
  this.Poly=new Array();
  this.PolyRank=new Array();
  this.Shape=new Array();
  this.zIndex=azIndex;
  this.Center=new V3D.Vector(0.0, 0.0, 0.0);
  this.Zoom=new V3D.Vector(1.0, 1.0, 1.0);
  this.OrderWeight=new V3D.Vector(1.0, 1.0, 1.0);
  this.ZoomAll=1.0;
  this.ShiftX=0.0;
  this.ShiftY=0.0;
  this.BoxGroup=null;
  this.PolyGroup=null;
  this.XM=100;
  this.YM=100;
  if ((aWidth)&&(aHeight))
  { this.XM=aWidth/2;
    this.YM=aHeight/2;
  }
  else
  { if ((aParentObj.style.width)&&(aParentObj.style.height))
    { this.XM=parseInt(aParentObj.style.width)/2;
      this.YM=parseInt(aParentObj.style.height)/2;
    }
  }
  this.Dist=1000.0;
  this.Viewer=new V3D.Vector(1000.0, 0.0, 0.0);
  this.Th=0.0; this.Ph=0.0;
  this.DiffuseLight=0.5;
  this.Light=new V3D.Vector(1.0, 0.0, 0.0);
  this.ThLight=0.0; this.PhLight=0.0;
  this.sin_Th=0.0; this.cos_Th=1.0; this.sin_Ph=0.0; this.cos_Ph=1.0;
  this.cos_Ph_sin_Th=0.0; this.sin_Ph_sin_Th=0.0; this.cos_Ph_cos_Th=1.0; this.sin_Ph_cos_Th=0.0;
  this.LightTh=0.0;
  this.LightPh=0.0;
  this.RankSort=function(ll, rr)
  { if (ll[1]>rr[1]) return(1);
    return(-1);
  };
  this.ChangeViewer=function(ddTh, ddPh)
  { var pi_d_180=3.14159265/180;
    if ((this.Th+ddTh>=-89.0)&&(this.Th+ddTh<=89.0)) this.Th+=ddTh;
    this.Ph+=ddPh;
    while (this.Ph<0.0) this.Ph+=360.0;
    while (this.Ph>=360.0) this.Ph-=360.0;
    this.sin_Th=Math.sin(this.Th*pi_d_180);
    this.cos_Th=Math.cos(this.Th*pi_d_180);
    this.sin_Ph=Math.sin(this.Ph*pi_d_180);
    this.cos_Ph=Math.cos(this.Ph*pi_d_180);
    this.cos_Ph_sin_Th=this.cos_Ph*this.sin_Th;
    this.sin_Ph_sin_Th=this.sin_Ph*this.sin_Th;
    this.cos_Ph_cos_Th=this.cos_Ph*this.cos_Th;
    this.sin_Ph_cos_Th=this.sin_Ph*this.cos_Th;
    this.Viewer.x=this.Center.x+this.cos_Ph_cos_Th*this.Dist;
    this.Viewer.y=this.Center.y-this.sin_Ph_cos_Th*this.Dist;
    this.Viewer.z=this.Center.z-this.sin_Th*this.Dist;
  };
  this.ChangeLight=function(ddTh, ddPh)
  { var pi_d_180=3.14159265/180;
    if ((this.ThLight+ddTh>=-89.0)&&(this.ThLight+ddTh<=89.0)) this.ThLight+=ddTh;
    this.PhLight+=ddPh;
    if (this.ThLight<-89.0) this.ThLight=-89.0;
    if (this.ThLight>89.0) this.ThLight=89.0;
    while (this.PhLight<0.0) this.PhLight+=360.0;
    while (this.PhLight>=360.0) this.PhLight-=360.0;
    this.Light.x=Math.cos(this.PhLight*pi_d_180)*Math.cos(this.ThLight*pi_d_180);
    this.Light.y=-Math.sin(this.PhLight*pi_d_180)*Math.cos(this.ThLight*pi_d_180);
    this.Light.z=-Math.sin(this.ThLight*pi_d_180);
  };
  this.AddPoly=function(oo)
  { var ii=this.Poly.length;
    this.Poly[ii]=oo;
    this.PolyRank[ii]=new Array(ii, 0);
    if (this.use=="svg")
    { this.Shape[ii]=this.Document.createElementNS("http://www.w3.org/2000/svg","path");
      this.Shape[ii].setAttribute("z-index",this.zIndex+ii+3);
      this.Parent.appendChild(this.Shape[ii]); 
    }
    //if (this.use=="canvas"); //do nothing
  };
  this.AutoCenter=function()
  { var ii, jj, vv, xxmin, xxmax, yymin, yymax, zzmin, zzmax;
    var ll=this.Poly.length;
    this.Center.Zoom(0.0);
    for (ii=0; ii<ll; ii++)
      this.Center.Add(this.Poly[ii].Center);
    if (ll>0) this.Center.Zoom(1.0/ll);
    xxmin=this.Center.x;
    xxmax=this.Center.x;
    yymin=this.Center.y;
    yymax=this.Center.y;
    zzmin=this.Center.z;
    zzmax=this.Center.z;
    for (ii=0; ii<ll; ii++)
    { for (jj=0; jj<this.Poly[ii].Point.length; jj++)
      { vv=this.Poly[ii].Point[jj];
        if (xxmin>vv.x) xxmin=vv.x;
        if (xxmax<vv.x) xxmax=vv.x;
        if (yymin>vv.y) yymin=vv.y;
        if (yymax<vv.y) yymax=vv.y;
        if (zzmin>vv.z) zzmin=vv.z;
        if (zzmax<vv.z) zzmax=vv.z;
      }
    }
    xxmax-=xxmin;
    yymax-=yymin;
    zzmax-=zzmin;
    vv=xxmax*xxmax+yymax*yymax+zzmax*zzmax;
    if (vv>0.0) ll=Math.sqrt(vv);
    else ll=19.0;
    if (this.XM<this.YM) this.ZoomAll=1.6*this.XM/ll;
    else this.ZoomAll=1.6*this.YM/ll;
    this.Dist=2*ll;
    this.ChangeViewer(0, 0);
  };
  this.ScreenPos=function(vv)
  { nn=new V3D.Vector(0,0,0);
    nn.x= this.sin_Ph*(vv.x-this.Center.x)
         +this.cos_Ph*(vv.y-this.Center.y);
    nn.y=-this.cos_Ph_sin_Th*(vv.x-this.Center.x)
         +this.sin_Ph_sin_Th*(vv.y-this.Center.y)
         -this.cos_Th*(vv.z-this.Center.z);
    nn.z= this.cos_Ph_cos_Th*(vv.x-this.Center.x)
         -this.sin_Ph_cos_Th*(vv.y-this.Center.y)
         -this.sin_Th*(vv.z-this.Center.z);
    if (this.Dist>0.0)
    { nn.x*=this.Dist/(this.Dist-nn.z);
      nn.y*=this.Dist/(this.Dist-nn.z);
    }
  //real world to screen:
    nn.Zoom(this.ZoomAll);
    nn.x+=this.XM+this.ShiftX;
    nn.y+=this.YM+this.ShiftY;
    return(nn);
  };
  this.Sort=function()
  { var ii, ll=this.Poly.length, xx, yy, zz;
    if (this.Dist==0.0)
    { for (ii=0; ii<ll; ii++)
      { this.PolyRank[ii][0]=ii;
        this.PolyRank[ii][1]=this.cos_Ph_cos_Th*this.Poly[ii].Center.x*this.OrderWeight.x
          -this.sin_Ph_cos_Th*this.Poly[ii].Center.y*this.OrderWeight.y
          -this.sin_Th*this.Poly[ii].Center.z*this.OrderWeight.z;
      }
    }
    else
    { for (ii=0; ii<ll; ii++)
      { this.PolyRank[ii][0]=ii;
        xx=this.Poly[ii].Center.x*this.OrderWeight.x-this.Viewer.x;
        yy=this.Poly[ii].Center.y*this.OrderWeight.y-this.Viewer.y;
        zz=this.Poly[ii].Center.z*this.OrderWeight.z-this.Viewer.z;
        this.PolyRank[ii][1]=-xx*xx-yy*yy-zz*zz;
      }
    }
    this.PolyRank.sort(this.RankSort);
  };
  this.Draw=function()
  { var cc, ii, ll=this.Poly.length;
    if (this.use=="canvas")
    { this.Context = this.Parent.getContext("2d");
      this.Context.clearRect(0, 0, this.Parent.width, this.Parent.height);
    }
    this.Light.Normalize();
    if (this.BoundingBox) this.BoundingBox.Draw();
    for (ii=0; ii<ll; ii++)
      this.Poly[this.PolyRank[ii][0]].Draw(this.Shape[ii]);
    if (this.use=="canvas")
    { for (var jj in this.Callback)
      { if (this.Callback[jj].isOn);
      	else
      	{ this.Parent.addEventListener(jj, (e) => { this.CanvasCallback(e); }, false);
      	  this.Callback[jj].isOn=1;
      	}
      }
    }
  };
  this.CanvasCallback=function(event)
  { var cc=this.Context, ii, ll=this.Poly.length, pp, tt=event.type;
    if (tt=="mousemove") tt="mouseover";
    this.Event.offsetX=event.offsetX;
    this.Event.offsetY=event.offsetY;
    for (ii=ll-1; ii>=0; ii--)
    { pp=this.Poly[this.PolyRank[ii][0]];
      if (cc.isPointInPath(pp.Path2D, event.offsetX, event.offsetY))    
      { if ((pp.Callback[event.type])||(pp.Callback[tt]))	
      	{ if ((this.CallbackPoly>=0)&&(this.CallbackPoly!=this.PolyRank[ii][0]))
      	  { if (this.Poly[this.CallbackPoly].Callback["mouseout"])
      	    { this.Event.target=this.Poly[this.CallbackPoly];
      	      this.Event.type="mouseout1";
      	      this.Poly[this.CallbackPoly].Callback["mouseout"](this.Event);
      	    }
      	    this.CallbackPoly=-1;
      	  }
      	  this.Event.target=pp;
      	  this.Event.type=tt;
      	  if(pp.Callback[tt])pp.Callback[tt](this.Event);
      	  this.CallbackPoly=this.PolyRank[ii][0];
          return;
        }
      }
    }
    if ((event.type=="mousemove")&&(this.CallbackPoly>=0))	
    { if (this.Poly[this.CallbackPoly].Callback["mouseout"]) 
      { pp=this.Poly[this.CallbackPoly];
      	this.Event.target=pp;
      	this.Event.type="mouseout2";
      	if(pp.Callback["mouseout"])pp.Callback["mouseout"](this.Event);
      }
      this.CallbackPoly=-1;
    }
  };
  this.Delete=function()
  { var ii, nn, ss;
    //if (this.use=="canvas"); //do nothing
    if (this.use=="svg")
    { ss=this.Parent;
      nn=ss.childNodes.length;
      for (ii=0; ii<nn; ii++)
        ss.removeChild(ss.lastChild);
    }
    this.BoundingBox=null;
    this.Poly.length=0;
    this.PolyRank.length=0;
    this.Shape.length=0;
    this.Callback.length=0;  
  };
  this.ZoomUpdate=function()
  { var ii, ll=this.Poly.length;
    for (ii=0; ii<ll; ii++)
      this.Poly[ii].ZoomUpdate();
  };
  this.GetFaceDir=function(nn, pp)
  { var zz;
    if (this.Dist==0.0)
      zz=-this.cos_Ph_cos_Th*nn.x+this.sin_Ph_cos_Th*nn.y+this.sin_Th*nn.z;
    else
      zz=(pp.x-this.Viewer.x)*nn.x+(pp.y-this.Viewer.y)*nn.y+(pp.z-this.Viewer.z)*nn.z;
    return(zz);
  };
  this.GetColor=function(cc0, cc1, nn, pp)
  { var rr, gg, bb, aa, hh="0123456789abcdef";
    var zz, vv;
    if (this.Dist==0.0)
      zz=-this.cos_Ph_cos_Th*nn.x+this.sin_Ph_cos_Th*nn.y+this.sin_Th*nn.z;
    else
      zz=(pp.x-this.Viewer.x)*nn.x+(pp.y-this.Viewer.y)*nn.y+(pp.z-this.Viewer.z)*nn.z;
    if (this.DiffuseLight==1.0)
    { if (zz>0) return(cc0);
      else return(cc1);
    }
    vv=nn.x*this.Light.x+nn.y*this.Light.y+nn.z*this.Light.z;
    if (zz>0)
    { vv*=-1;
      if (cc0.length>=7)
      { rr=parseInt(cc0.substr(1,2),16);
        gg=parseInt(cc0.substr(3,2),16);
        bb=parseInt(cc0.substr(5,2),16);
        aa=parseInt(cc0.substr(7,2),16);
      }
      else
      { rr=parseInt(cc0.substr(1,1),16)*17;
        gg=parseInt(cc0.substr(2,1),16)*17;
        bb=parseInt(cc0.substr(3,1),16)*17;
        aa=parseInt(cc0.substr(4,1),16)*17;
      }
    }
    else
    { if (cc0.length>=7)
      { rr=parseInt(cc1.substr(1,2),16);
        gg=parseInt(cc1.substr(3,2),16);
        bb=parseInt(cc1.substr(5,2),16);
        aa=parseInt(cc1.substr(7,2),16);
      }
      else
      { rr=parseInt(cc1.substr(1,1),16)*17;
        gg=parseInt(cc1.substr(2,1),16)*17;
        bb=parseInt(cc1.substr(3,1),16)*17;
        aa=parseInt(cc1.substr(4,1),16)*17;
      }        
    }
    if (vv<=0)
    { rr=Math.floor(rr*this.DiffuseLight); 
      gg=Math.floor(gg*this.DiffuseLight);
      bb=Math.floor(bb*this.DiffuseLight);
    }
    else
    { rr=Math.floor(rr*(vv*(1-this.DiffuseLight)+this.DiffuseLight)); 
      gg=Math.floor(gg*(vv*(1-this.DiffuseLight)+this.DiffuseLight)); 
      bb=Math.floor(bb*(vv*(1-this.DiffuseLight)+this.DiffuseLight)); 
    }
    var ss="#";
    ss+=hh.charAt(Math.floor(rr/16))+hh.charAt(rr%16);
    ss+=hh.charAt(Math.floor(gg/16))+hh.charAt(gg%16);
    ss+=hh.charAt(Math.floor(bb/16))+hh.charAt(bb%16);
    if (!isNaN(aa)) ss+=hh.charAt(Math.floor(aa/16))+hh.charAt(aa%16);
    return(ss);
  };
  this.Init=function()
  { if (this.use=="svg")
    { this.BoxGroup=this.Document.createElementNS("http://www.w3.org/2000/svg","g");
      this.BoxGroup.setAttribute("x","0");
      this.BoxGroup.setAttribute("y","0");
      this.BoxGroup.setAttribute("width",this.XM*2);
      this.BoxGroup.setAttribute("height",this.YM*2);
      this.Parent.appendChild(this.BoxGroup);
      this.PolyGroup=this.Document.createElementNS("http://www.w3.org/2000/svg","g");
      this.PolyGroup.setAttribute("x","0");
      this.PolyGroup.setAttribute("y","0");
      this.PolyGroup.setAttribute("width",this.XM*2);
      this.PolyGroup.setAttribute("height",this.YM*2);
      this.Parent.appendChild(this.PolyGroup);  
    }
    //if (this.use=="canvas"); //do nothing	
  };
  this.Callback=new Array();
  this.Event = { type:"", offsetX:0, offsetY:0, target:null };
  this.CallbackPoly=-1;
  this.Init();
  //return(this);
},

Poly3D:function(aParentScene, aFrontColor, aBackColor, aStrokeColor, aStrokeWeight)
{ this.Parent=aParentScene;
  this.ClassName="Poly3D";
  this.PhPoint=new Array();
  this.Point=new Array();
  this.Center=new V3D.Vector(0.0, 0.0, 0.0);
  this.Normal=new V3D.Vector(1.0, 0.0, 0.0);
  this.FrontColor="";
  if (aFrontColor) this.FrontColor=aFrontColor.toLowerCase();
  this.BackColor="";
  if (aBackColor) this.BackColor=aBackColor.toLowerCase();
  this.StrokeColor="";
  if (aStrokeColor) this.StrokeColor=aStrokeColor.toLowerCase();
  this.StrokeWeight=aStrokeWeight;
  this.Visibility="visible";
  this.AddPoint=function(xx, yy, zz)
  { vv=this.Parent.Zoom;
    this.PhPoint[this.PhPoint.length]=new V3D.Vector(xx, yy, zz);
    this.Point[this.Point.length]=new V3D.Vector(xx*vv.x, yy*vv.y, zz*vv.z);
  };
  this.SetPoint=function(ii, xx, yy, zz)
  { vv=this.Parent.Zoom;
    this.PhPoint[ii].x=xx;
    this.PhPoint[ii].y=yy;
    this.PhPoint[ii].z=zz;
    this.Point[ii].x=xx*vv.x;
    this.Point[ii].y=yy*vv.y;
    this.Point[ii].z=zz*vv.z;
  };
  this.Zoom=function(ff)
  { for (var ii=0; ii<this.PhPoint.length; ii++)
      this.PhPoint[ii].Zoom(ff);
    for (var ii=0; ii<this.Point.length; ii++)
      this.Point[ii].Zoom(ff);
    this.Update();
  };
  this.Shift=function(xx, yy, zz)
  { vv=this.Parent.Zoom;
    for (var ii=0; ii<this.PhPoint.length; ii++)
    { this.PhPoint[ii].x+=xx;
      this.PhPoint[ii].y+=yy;
      this.PhPoint[ii].z+=zz;
    }
    for (var ii=0; ii<this.Point.length; ii++)
    { this.Point[ii].x+=xx*vv.x;
      this.Point[ii].y+=yy*vv.y;
      this.Point[ii].z+=zz*vv.z;
    }
    this.Center.x+=xx*vv.x;
    this.Center.y+=yy*vv.y;
   this.Center.z+=zz*vv.z;
  };
  this.Update=function()
  { var ii, ll=this.Point.length;
    this.Center.Zoom(0.0);
    for (ii=0; ii<ll; ii++)
      this.Center.Add(this.Point[ii]);
    this.Center.Zoom(1.0/ll);
    if (ll>2)
    { var xx0=this.Point[0].x-this.Center.x;
      var yy0=this.Point[0].y-this.Center.y;
      var zz0=this.Point[0].z-this.Center.z;
      var xx1=this.Point[1].x-this.Center.x;
      var yy1=this.Point[1].y-this.Center.y;
      var zz1=this.Point[1].z-this.Center.z;
      this.Normal.x=yy0*zz1-zz0*yy1;
      this.Normal.y=zz0*xx1-xx0*zz1;
      this.Normal.z=xx0*yy1-yy0*xx1;
      this.Normal.Normalize();
    }
  };
  this.Draw=function(aShape)
  { var cc, ii, ss, ww, ll=this.Point.length;
    var vv=this.Parent.ScreenPos(this.Point[0]);
    if (this.Parent.use=="svg")
    { aShape.setAttribute("visibility",this.Visibility);
      if (this.Visibility=="visible")
      { ss="M "+parseInt(vv.x)+" "+parseInt(vv.y)+" ";
        for (ii=1; ii<ll; ii++)
        { vv=this.Parent.ScreenPos(this.Point[ii]);
          ss+="L "+parseInt(vv.x)+" "+parseInt(vv.y)+" ";
        }
        ss+="z";
        aShape.setAttribute("d", ss);
        if ((ll>=3)&&(this.FrontColor!="")) 
          aShape.setAttribute("fill",this.Parent.GetColor(this.FrontColor, this.BackColor, this.Normal, this.Center));
        else aShape.setAttribute("fill","none");
        if (this.StrokeColor) aShape.setAttribute("stroke",this.StrokeColor);
        else aShape.setAttribute("stroke",this.Parent.GetColor(this.FrontColor, this.BackColor, this.Normal, this.Center));
        aShape.setAttribute("stroke-width",this.StrokeWeight); 
      }
      aShape.id=this.id;
      for (var jj in this.Parent.Callback)
      { aShape.removeEventListener(jj, this.Parent.Callback[jj], false);
        if (this.Callback[jj]) aShape.addEventListener(jj, this.Callback[jj], false);
      }
    }
    if (this.Parent.use=="canvas")
    { if (this.Visibility=="visible")
      { cc = this.Parent.Context;
        if ((ll>=3)&&(this.FrontColor!="")) cc.fillStyle = this.Parent.GetColor(this.FrontColor, this.BackColor, this.Normal, this.Center);
        this.Path2D = new Path2D();       
        this.Path2D.moveTo(parseInt(vv.x), parseInt(vv.y));
        for (ii=1; ii<ll; ii++)
        { vv=this.Parent.ScreenPos(this.Point[ii]);
          this.Path2D.lineTo(parseInt(vv.x), parseInt(vv.y));  
        }
        this.Path2D.closePath();       
        if ((ll>=3)&&(this.FrontColor!="")) cc.fill(this.Path2D);
        ww=this.StrokeWeight; 
        if ((this.StrokeColor)&&(ww>0)) 
        { cc.strokeStyle=this.StrokeColor;   
          if ((ll>=3)&&(this.StrokeWeight>1))
          { cc.lineWidth=ww+1;  
            cc.save();
            cc.clip(this.Path2D);
            cc.stroke(this.Path2D);
            cc.restore();
          }
          else 
          { cc.lineWidth=ww;  
            cc.stroke(this.Path2D);
          }
        }
      }
    }    
  };
  this.ZoomUpdate=function()
  { var ii, ll=this.Point.length, vv=this.Parent.Zoom;
    for (ii=0; ii<ll; ii++)
    { this.Point[ii].x=this.PhPoint[ii].x*vv.x;
      this.Point[ii].y=this.PhPoint[ii].y*vv.y;
      this.Point[ii].z=this.PhPoint[ii].z*vv.z;
    }
    this.Update();
  };
  this.id="";
  this.Callback=new Array();
  this.Parent.AddPoly(this);  
},

Box3D:function(aParentScene, aX0,aY0,aZ0, aX1,aY1,aZ1, aFrontColor, aBackColor, aStrokeColor, aStrokeWeight, aMsg)
{ V3D.Object3D.call(this);
  this.Parent=aParentScene;
  this.ClassName="Box3D";
  this.Center.Set((aX0+aX1)/2,(aY0+aY1)/2,(aZ0+aZ1)/2);
  if (aFrontColor) this.FrontColor=aFrontColor.toLowerCase();
  this.BackColor="";
  if (aBackColor) this.BackColor=aBackColor.toLowerCase();
  this.StrokeColor="";
  if (aStrokeColor) this.StrokeColor=aStrokeColor.toLowerCase();
  this.StrokeWeight=aStrokeWeight;
  this.SetPosition=function(aX0,aY0,aZ0, aX1,aY1,aZ1)
  { with (this.Poly3D[0])
    { SetPoint(0,aX0,aY0,aZ0); SetPoint(1,aX1,aY0,aZ0); SetPoint(2,aX1,aY1,aZ0); SetPoint(3,aX0,aY1,aZ0); Update(); }
    with (this.Poly3D[1])
    { SetPoint(0,aX0,aY1,aZ1); SetPoint(1,aX1,aY1,aZ1); SetPoint(2,aX1,aY0,aZ1); SetPoint(3,aX0,aY0,aZ1); Update(); }
    with (this.Poly3D[2])
    { SetPoint(0,aX0,aY0,aZ1); SetPoint(1,aX1,aY0,aZ1); SetPoint(2,aX1,aY0,aZ0); SetPoint(3,aX0,aY0,aZ0); Update(); }
    with (this.Poly3D[3])
    { SetPoint(0,aX0,aY1,aZ0); SetPoint(1,aX1,aY1,aZ0); SetPoint(2,aX1,aY1,aZ1); SetPoint(3,aX0,aY1,aZ1); Update(); }
    with (this.Poly3D[4])
    { SetPoint(0,aX0,aY1,aZ0); SetPoint(1,aX0,aY1,aZ1); SetPoint(2,aX0,aY0,aZ1); SetPoint(3,aX0,aY0,aZ0); Update(); }
    with (this.Poly3D[5])
    { SetPoint(0,aX1,aY0,aZ0); SetPoint(1,aX1,aY0,aZ1); SetPoint(2,aX1,aY1,aZ1); SetPoint(3,aX1,aY1,aZ0); Update(); }
  };
  this.Poly3D[0]=new V3D.Poly3D(aParentScene, aFrontColor, aBackColor, aStrokeColor, aStrokeWeight);
  with (this.Poly3D[0])
  { AddPoint(aX0,aY0,aZ0); AddPoint(aX1,aY0,aZ0); AddPoint(aX1,aY1,aZ0); AddPoint(aX0,aY1,aZ0); Update(); }
  this.Poly3D[1]=new V3D.Poly3D(aParentScene, aFrontColor, aBackColor, aStrokeColor, aStrokeWeight);
  with (this.Poly3D[1])
  { AddPoint(aX0,aY0,aZ1); AddPoint(aX0,aY1,aZ1); AddPoint(aX1,aY1,aZ1); AddPoint(aX1,aY0,aZ1); Update(); }
  this.Poly3D[2]=new V3D.Poly3D(aParentScene, aFrontColor, aBackColor, aStrokeColor, aStrokeWeight);
  with (this.Poly3D[2])
  { AddPoint(aX0,aY0,aZ1); AddPoint(aX1,aY0,aZ1); AddPoint(aX1,aY0,aZ0); AddPoint(aX0,aY0,aZ0); Update(); }
  this.Poly3D[3]=new V3D.Poly3D(aParentScene, aFrontColor, aBackColor, aStrokeColor, aStrokeWeight);
  with (this.Poly3D[3])
  { AddPoint(aX0,aY1,aZ0); AddPoint(aX1,aY1,aZ0); AddPoint(aX1,aY1,aZ1); AddPoint(aX0,aY1,aZ1); Update(); }
  this.Poly3D[4]=new V3D.Poly3D(aParentScene, aFrontColor, aBackColor, aStrokeColor, aStrokeWeight);
  with (this.Poly3D[4])
  { AddPoint(aX0,aY1,aZ0); AddPoint(aX0,aY1,aZ1); AddPoint(aX0,aY0,aZ1); AddPoint(aX0,aY0,aZ0); Update(); }
  this.Poly3D[5]=new V3D.Poly3D(aParentScene, aFrontColor, aBackColor, aStrokeColor, aStrokeWeight);
  with (this.Poly3D[5])
  { AddPoint(aX1,aY0,aZ0); AddPoint(aX1,aY0,aZ1); AddPoint(aX1,aY1,aZ1); AddPoint(aX1,aY1,aZ0); Update(); }
},

Line:function(aParentScene, aX0, aY0, aZ0, aX1, aY1, aZ1, aStrokeColor, aStrokeWeight)
{ V3D.Object3D.call(this);
  this.Parent=aParentScene;
  this.ClassName="Line";
  this.Center.Set((aX0+aX1)/2,(aY0+aY1)/2,(aZ0+aZ1)/2);
  this.FrontColor="";
  this.BackColor="";
  this.StrokeColor="";
  if (aStrokeColor) this.StrokeColor=aStrokeColor.toLowerCase();
  this.StrokeWeight=aStrokeWeight;
  this.Poly3D[0]=new V3D.Poly3D(aParentScene, "", "", aStrokeColor, aStrokeWeight);
  with (this.Poly3D[0])
  { AddPoint(aX0,aY0,aZ0); AddPoint(aX1,aY1,aZ1); Update(); }
},

CoordSys:function(aParentScene, aStrokeColor)
{ V3D.Object3D.call(this);
  this.Parent=aParentScene;
  this.ClassName="CoordSys";
  this.Center=new V3D.Vector(0,0,0);
  this.FrontColor="";
  this.BackColor="";  
  this.StrokeColor="";
  if (aStrokeColor) this.StrokeColor=aStrokeColor.toLowerCase();
  this.StrokeWeight=1;
  this.TransformCoord=function(vv)
  { vvv=new V3D.Vector(this.Poly3D[0].Point[0].x, this.Poly3D[0].Point[0].y, this.Poly3D[0].Point[0].z);
    vvv.x+=
    (this.Poly3D[0].Point[1].x-this.Poly3D[0].Point[0].x)*vv.x+
    (this.Poly3D[0].Point[2].x-this.Poly3D[0].Point[0].x)*vv.y+
    (this.Poly3D[0].Point[3].x-this.Poly3D[0].Point[0].x)*vv.z;
    vvv.y+=
    (this.Poly3D[0].Point[1].y-this.Poly3D[0].Point[0].y)*vv.x+
    (this.Poly3D[0].Point[2].y-this.Poly3D[0].Point[0].y)*vv.y+
    (this.Poly3D[0].Point[3].y-this.Poly3D[0].Point[0].y)*vv.z;
    vvv.z+=
    (this.Poly3D[0].Point[1].z-this.Poly3D[0].Point[0].z)*vv.x+
    (this.Poly3D[0].Point[2].z-this.Poly3D[0].Point[0].z)*vv.y+
    (this.Poly3D[0].Point[3].z-this.Poly3D[0].Point[0].z)*vv.z;
    return(vvv);
  };
  this.Poly3D[0]=new V3D.Poly3D(aParentScene, "", "", this.StrokeColor, this.StrokeWeight);
  with (this.Poly3D[0])
  { AddPoint(0,0,0); AddPoint(1,0,0); AddPoint(0,1,0); AddPoint(0,0,1); Update(); }
  if (aStrokeColor=="") this.SetVisibility(false);
  //This is a helper class to track the coordinates of an object 
  //after several rotation, shift and zoom operations
},

Object3D:function()
{ this.Parent=null;
  this.ClassName="Object3D";
  this.Center=new V3D.Vector(0,0,0);
  this.FrontColor="";
  this.BackColor="";
  this.StrokeColor="";
  this.StrokeWeight=1;
  this.Poly3D=new Array();
  this.Zoom=function(ff)
  { for (var ii=0; ii<this.Poly3D.length; ii++) this.Poly3D[ii].Zoom(ff);
    this.Center.Zoom(ff);
  };
  this.Shift=function(xx, yy, zz)
  { for (var ii=0; ii<this.Poly3D.length; ii++) this.Poly3D[ii].Shift(xx, yy, zz);
    this.Center.x+=xx;
    this.Center.y+=yy;
    this.Center.z+=zz;
  };
  this.SetFrontColor=function(aFrontColor)
  { for (var ii=0; ii<this.Poly3D.length; ii++) this.Poly3D[ii].FrontColor=aFrontColor;
  };
  this.SetFrontColor=function(aBackColor)
  { for (var ii=0; ii<this.Poly3D.length; ii++) this.Poly3D[ii].BackColor=aBackColor;
  };
  this.SetFrontColor=function(aStrokeColor)
  { for (var ii=0; ii<this.Poly3D.length; ii++) this.Poly3D[ii].StrokeColor=aStrokeColor;
  };
  this.SetFrontColor=function(aStrokeWeight)
  { for (var ii=0; ii<this.Poly3D.length; ii++) this.Poly3D[ii].StrokeWeight=aStrokeWeight;
  }; 
  this.SetVisibility=function(isVisible)
  { for (var ii=0; ii<this.Poly3D.length; ii++) 
      this.Poly3D[ii].Visibility=((isVisible)&&(isVisible!="hidden")) ? "visible" : "hidden";
  }; 
  this.RotateX=function(aPh,aCenter)
  { var ii, jj, yy, zz;
    var ccos_Ph=Math.cos(aPh*3.14159265/180);
    var ssin_Ph=Math.sin(aPh*3.14159265/180);
    for (ii=0; ii<this.Poly3D.length; ii++)
    { for (jj=0; jj<this.Poly3D[ii].Point.length; jj++)
      { yy=this.Poly3D[ii].Point[jj].y-aCenter*this.Center.y;
        zz=this.Poly3D[ii].Point[jj].z-aCenter*this.Center.z;
        this.Poly3D[ii].Point[jj].y=aCenter*this.Center.y+ccos_Ph*yy-ssin_Ph*zz;
        this.Poly3D[ii].Point[jj].z=aCenter*this.Center.z+ssin_Ph*yy+ccos_Ph*zz;
      }
      this.Poly3D[ii].Update();
    }
  };
  this.RotateY=function(aPh,aCenter)
  { var ii, jj, zz, xx;
    var ccos_Ph=Math.cos(aPh*3.14159265/180);
    var ssin_Ph=Math.sin(aPh*3.14159265/180);
    for (ii=0; ii<this.Poly3D.length; ii++)
    { for (jj=0; jj<this.Poly3D[ii].Point.length; jj++)
      { zz=this.Poly3D[ii].Point[jj].z-aCenter*this.Center.z;
        xx=this.Poly3D[ii].Point[jj].x-aCenter*this.Center.x;
        this.Poly3D[ii].Point[jj].z=aCenter*this.Center.z+ccos_Ph*zz-ssin_Ph*xx;
        this.Poly3D[ii].Point[jj].x=aCenter*this.Center.x+ssin_Ph*zz+ccos_Ph*xx;
      }
      this.Poly3D[ii].Update();
    }
  };
  this.RotateZ=function(aPh,aCenter)
  { var ii, jj, xx, yy;
    var ccos_Ph=Math.cos(aPh*3.14159265/180);
    var ssin_Ph=Math.sin(aPh*3.14159265/180);
    for (ii=0; ii<this.Poly3D.length; ii++)
    { for (jj=0; jj<this.Poly3D[ii].Point.length; jj++)
      { xx=this.Poly3D[ii].Point[jj].x-aCenter*this.Center.x;
        yy=this.Poly3D[ii].Point[jj].y-aCenter*this.Center.y;
        this.Poly3D[ii].Point[jj].x=aCenter*this.Center.x+ccos_Ph*xx-ssin_Ph*yy;
        this.Poly3D[ii].Point[jj].y=aCenter*this.Center.y+ssin_Ph*xx+ccos_Ph*yy;
      }
      this.Poly3D[ii].Update();
    }
  };
  this.SetId=function(aId)
  { for (var ii=0; ii<this.Poly3D.length; ii++)
    { this.Poly3D[ii].id=aId;
    }
  };
  this.SetEventAction=function(aEvent,aCallback)
  { if ((this.Parent.use=="canvas")&&((aEvent=="mouseover")||(aEvent=="mouseout")))
    { if(!this.Parent.Callback["mousemove"]) this.Parent.Callback["mousemove"]={};
    }
    if(aCallback) this.Parent.Callback[aEvent]=aCallback;
    for (var ii=0; ii<this.Poly3D.length; ii++)
    { this.Poly3D[ii].Callback[aEvent]=aCallback;
    }
  };
}

};
